
;--------------------------
DMD_TSM:

	ldiw	Z,DMD_C
	lds	temp2,TSM_TH
	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	st	Z+,loop
	st	Z+,temp2
	sti	Z+,':'

	lds	temp2,TSM_TM
	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	st	Z+,loop
	st	Z+,temp2
	sti	Z+,'.'

	ldi	temp2,0
	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	st	Z+,loop
	st	Z+,temp2

	ldi	temp,0
	ldi	temp2,8
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
	rcall	DSENDS		;DMDSTA=0,DMDNUM=8

	ret
;----------------------------------------
DMDINC:

	ldiw	Z,DMD_C
	mov	temp2,TimeH
	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	st	Z+,loop
	st	Z+,temp2
	sti	Z+,':'

	mov	temp2,TimeM
	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	st	Z+,loop
	st	Z+,temp2
	sti	Z+,'.'

	mov	temp2,TimeS
	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	st	Z+,loop
	st	Z+,temp2

	ldi	temp,0
	ldi	temp2,8
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
	rcall	DSENDS		;DMDSTA=0,DMDNUM=8

	ret


DMDINC2:

	ldiw	Z,DMD_C
	sti	Z+,' '
	mov	temp2,TimeH
	cpi	temp2,0		;=0
	brne	PS_HEQ0	
	ldi	temp2,12
	rjmp	PS_HU12
PS_HEQ0:
	cpi	temp2,13	;11-13=c1 12-13=c1 13-13=c0 14-13=c0 24-13=c0 
	brcs	PS_HU12
	subi	temp2,12	;13-12=1 23-12=11
PS_HU12:

	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	cpi	loop,'0'	;10h=0?
	brne	PC+4
	sti	Z+,' '
	rjmp	PC+2

	st	Z+,loop

	st	Z+,temp2
	sti	Z+,':'

	mov	temp2,TimeM
	rcall	LPSNUM
	ldi	temp,'0'
	add	loop,temp	;charactor code '0'+num
	add	temp2,temp
	st	Z+,loop
	st	Z+,temp2
	sti	Z+,' '

	sti	Z+,' '		;sec:null
	sti	Z+,' '

	ldi	temp,0
	ldi	temp2,8
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
	rcall	DSENDS		;DMDSTA=0,DMDNUM=8

	ret


;----------------
LPSNUM:	clr	loop		;segment 2
	ldi	temp,10
LSNUM1:	cp	temp2,temp	;segment 1
	brcs	SNM10
	sub	temp2,temp
	inc	loop
	rjmp	LSNUM1
SNM10:	ret
;-----------------------------------





;-----------------------lcd character initialize
DMDINI:
	sts	DMDSTA,ZEROR
	sts	DMDNUM,ZEROR	
	sts	DMDDIM,ZEROR	;dmd counter clear

	cbi	PORTB,nRST	;reset acrive
	nop
	nop
	sbi	PORTB,nRST	;reset inactive

	clr	temp
	rcall	WAITS		;reset wait 3*256 step

				;portB7 B6 B5 B4  B3 B2 B1  B0
				;    A4 A3 A2 /wr A1 A0 /FL /RST
				;
	ldi	temp,0b10001000 ;all flash ram clear
	out	PORTA,temp
	ldi	temp,0b10010011	;control word reg sel
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR

	clr	temp
	rcall	WAITS		;reset wait 3*256 step
	

;	ldi	temp,0b00000001	;flash chr =blink set
;	out	PORTA,temp
;	ldi	temp,0b11011101	;flash chr3 set
;	out	PORTB,temp
;	cbi	PORTB,nWR
;	nop
;	sbi	PORTB,nWR

	ret
;-------------------- blink set
DMD_BLSET:
				;portB7 B6 B5 B4  B3 B2 B1  B0
				;    A4 A3 A2 /wr A1 A0 /FL /RST

	ldi	temp,0b00001000 ;blink =on
	out	PORTA,temp
	ldi	temp,0b10010011	;control word reg sel
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	ret

DMD_BLCLR:
				;portB7 B6 B5 B4  B3 B2 B1  B0
				;    A4 A3 A2 /wr A1 A0 /FL /RST

	ldi	temp,0b00000000 ;blink=off
	out	PORTA,temp
	ldi	temp,0b10010011	;control word reg sel
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	ret

		
;---------------------
DSENDS:				;DMD charactor send with scroll
				; 0b10010011 control word reg	
				; 0b11(2)1(1)(0)11 charactor ram
				; PORTB: A4,A3,A2,nWR,A1,A0,nFL,nRST
	lds	temp,DMDSTA
	lds	temp2,DMDNUM

	subi	temp2,8
	sub	temp2,temp	;DMDNUM-8-DMDSTA
	brcc	DSEN_P1		;>=0 ->draw
	ret			;<0  ->fin
	
DSEN_P1:
	ldiw	Z,DMD_C		;DMD charactor head
	add	ZL,temp		;+DMDSTA
	adc	ZH,ZEROR
	inc	temp
	sts	DMDSTA,temp	;DMDSTA+1

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11010011	;chr 0
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11010111	;chr 1
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11011011	;chr 2
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11011111	;chr 3
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11110011	;chr 4
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11110111	;chr 5
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11111011	;chr 6
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	ld	temp,Z+
	out	PORTA,temp
	ldi	temp,0b11111111	;chr 7
	out	PORTB,temp
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	lds	temp,DMDSTA
	inc	temp
	sts	DMDSTA,temp	;DMDSTA+1	;//ڔzłɁ{P(܂2ÂXN[)

	ret

;----------------------- DMD USER Charactor set
DMDCHRSET:	
	ld	temp2,Z+
	;-----------------	;portB7 B6 B5 B4  B3 B2 B1  B0
	ldi	temp,0b00000000 ;    A4 A3 A2 /wr A1 A0 /FL /RST
	andi	temp2,0x0F	 ;mask 0b00001111
	add	temp,temp2	 ;UDC Code Set
	out	PORTA,temp
	ldi	temp,0b00010011	;UDC reg sel
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	;-----------------
	ld	temp2,Z+	
	out	PORTA,temp2	;Dot Data Set
	ldi	temp,0b01010011	;UDC RAM Add sel(Row=0)
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	;-----------------
	ld	temp2,Z+	
	out	PORTA,temp2	;Dot Data Set
	ldi	temp,0b01010111	;UDC RAM Add sel(Row=1)
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	;-----------------
	ld	temp2,Z+	
	out	PORTA,temp2	;Dot Data Set
	ldi	temp,0b01011011	;UDC RAM Add sel(Row=2)
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	;-----------------
	ld	temp2,Z+	
	out	PORTA,temp2	;Dot Data Set
	ldi	temp,0b01011111	;UDC RAM Add sel(Row=3)
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	;-----------------
	ld	temp2,Z+	
	out	PORTA,temp2	;Dot Data Set
	ldi	temp,0b01110011	;UDC RAM Add sel(Row=4)
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	;-----------------
	ld	temp2,Z+	
	out	PORTA,temp2	;Dot Data Set
	ldi	temp,0b01110111	;UDC RAM Add sel(Row=5)
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	;-----------------
	ld	temp2,Z+	
	out	PORTA,temp2	;Dot Data Set
	ldi	temp,0b01111011	;UDC RAM Add sel(Row=6)
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	ret
