;----- ---------------------------------------------------mode4 Time Shock
MODE_4:
	mov	temp,TimeS
	cpi	temp,58
	brcs	M4PS0		
	rjmp	MODE_7		;TimeS=>58
M4PS0:	cpi	temp,0
	breq	M4CASE0		;TimeS=0
	clr	loop
	ldi	temp2,5
M4LP1:	sub	temp,temp2
	brcs	M4PS1
	add	loop,temp2
	rjmp	M4LP1
M4PS1:	add	temp,temp2
	cpi	temp,1
	brne	M4_ED

	ldiw	Z,dim_fs
	add	ZL,frame
	adc	ZH,ZEROR
	ld	temp2,Z
	ldiw	Z,leddot
	add	ZL,loop
	adc	ZH,ZEROR
	std	Z+1,temp2
	std	Z+2,temp2
	std	Z+3,temp2
	std	Z+4,temp2
	std	Z+5,temp2

	cpi	frame,1
	brne	M4_ED

M4PS3:	cpi	loop,0		;T*5=0->pass
	breq	M4_ED
	
	subi	ZL,4
	sbc	ZH,ZEROR	;Z-4			
	sti	Z,dim_1		;-4
	stdi	Z+1,dim_1	;-3
	stdi	Z+2,dim_1	;-2
	stdi	Z+3,dim_1	;-1
	stdi	Z+4,dim_1	;0
	rjmp	M4_ED

M4CASE0:
	cpi	frame,5
	brne	M4_ED
	ldiw	Z,leddot
	sti	Z,dim_1
	stdi	Z+5,dim_1
	stdi	Z+10,dim_1
	stdi	Z+15,dim_1
	stdi	Z+20,dim_1
	stdi	Z+25,dim_1
	stdi	Z+30,dim_1
	stdi	Z+35,dim_1
	stdi	Z+40,dim_1
	stdi	Z+45,dim_1
	stdi	Z+50,dim_1
	stdi	Z+55,dim_1
M4_ED:	ret
;--------------------------
;------------------------------ mode4 initialize----
MODE_4INI:
	rcall	DOTACLR
	mov	temp,TimeS
	cpi	temp,58
	brcc	M4I_ED		;>58 ->END

	ldiw	Z,leddot
	sti	Z,dim_1
	stdi	Z+5,dim_1
	stdi	Z+10,dim_1
	stdi	Z+15,dim_1
	stdi	Z+20,dim_1
	stdi	Z+25,dim_1
	stdi	Z+30,dim_1
	stdi	Z+35,dim_1
	stdi	Z+40,dim_1
	stdi	Z+45,dim_1
	stdi	Z+50,dim_1
	stdi	Z+55,dim_1

	mov	temp,TimeS
	cpi	temp,1
	brcs	M4I_ED
	dec	temp	;TimeS-1
	clr	loop
	ldi	temp2,5
M4ILP1:	sub	temp,temp2
	brcs	M4IPS1
	inc	loop
	rjmp	M4ILP1
M4IPS1:	add	temp,temp2
;	cpi	loop,0
;	breq	M4I_ED
M4IPS2:
	inc	loop
M4ILP2:
	mov	temp2,loop
	lsl	temp2
	lsl	temp2
	add	temp2,loop
	ldiw	Z,leddot
	add	ZL,temp2
	adc	ZH,ZEROR

	subi	ZL,4
	sbc	ZH,ZEROR	;Z-4
	sti	Z,dim_1		;-4
	stdi	Z+1,dim_1	;-3
	stdi	Z+2,dim_1	;-2
	stdi	Z+3,dim_1	;-1
	stdi	Z+4,dim_1		;0

	dec	loop
	brne	M4ILP2
M4I_ED:	ret

;-----------------------------------------------------

;------------------------------------------------------------- mode7 ROLLING
MODE_7:	

	mov	temp2,frame
	mov	temp,TimeS
	ror	temp		;TimeS=odd->+31(frame)
	brcc	M7_PS1
	ldi	temp,31
	add	temp2,temp	
M7_PS1:
	cpi	temp2,0
	breq	M7CF0
	cpi	temp2,1
	breq	M7CF1
	cpi	temp2,2
	breq	M7CF2
	cpi	temp2,59
	brcs	M7CF358
	cpi	temp2,59
	breq	M7CF59
	cpi	temp2,60
	breq	M7CF60
	cpi	temp2,61
	breq	M7CF61
	rjmp	M7_ED	;other

M7CF0:
	ldiw	Z,leddot
	sti	Z,dim_8
	rjmp	M7_ED
	
M7CF1:
	ldiw	Z,leddot
	sti	Z,dim_5
	stdi	Z+1,dim_8
	rjmp	M7_ED

M7CF2:
	ldiw	Z,leddot
	sti	Z,dim_2
	stdi	Z+1,dim_5
	stdi	Z+2,dim_8
	rjmp	M7_ED

M7CF358:
	ldiw	Z,leddot
	add	ZL,temp2	;Frame(2sec)
	adc	ZH,ZEROR
	subi	ZL,3
	sbc	ZH,ZEROR	;Z-3
	sti	Z,dim_0		;-3
	stdi	Z+1,dim_2	;-2
	stdi	Z+2,dim_5	;-1
	stdi	Z+3,dim_8	;0
	rjmp	M7_ED

M7CF59:
	ldiw	Z,leddot
	stdi	Z+56,dim_0
	stdi	Z+57,dim_0
	stdi	Z+58,dim_3
	stdi	Z+59,dim_8
	rjmp	M7_ED
M7CF60:
	ldiw	Z,leddot
	stdi	Z+58,dim_0
	stdi	Z+59,dim_3
	rjmp	M7_ED

M7CF61:
	ldiw	Z,leddot
	stdi	Z+59,dim_0
	rjmp	M7_ED

M7_ED:	ret
;------------------------------ mode7 initialize----
MODE_7INI:
	rcall	DOTACLR	
	ret
;-------------------------------------------------------------- mode5 WHEEL
MODE_5:
	mov	temp,frame
	cpi	temp,1
	brne	M5_PS1	;at Frame=1
			;leddot(0:59)<-leddot(1:59,0) shift
	mov	temp,TimeS
	cpi	temp,11
	brcs	M5_PS1	;TimeS<11 ->pass
	cpi	temp,58
	brcc	M5_PS1	;TimeS=>58 ->pass
	
	ldiw	Z,leddot
	ldi	temp,60
	add	ZL,temp
	adc	ZH,ZEROR	;Z=leddot+60
	lds	temp2,leddot	;led:0(Z=0)->temp2
	ld	temp,-Z		;(Z=59)
	sts	leddot,temp	;->led:0(Z=0)

	ldi	loop,58
M5_LP1:	ld	temp,-Z		;led58..1(Z=58..1)
	std	Z+1,temp	;->led59..2
	dec	loop
	brne	M5_LP1
	st	Z,temp2		;temp2->led1(Z=1)

M5_PS1:	
	mov	temp,TimeS
	cpi	temp,0
	breq	M5_ED		;TimeS=0
	cpi	temp,11
	brcs	M5_CT0110	;TimeS<11
	cpi	temp,51
	brcs	M5_CT1150	;TimeS<51
	cpi	temp,58
	brcs	M5_PS0
	rjmp	MODE_7		;TimeS=>58
M5_PS0:	rjmp	M5_ED		;other(TimeS=>51)

M5_CT0110:		;-------- case TimeS:1-10
	mov	temp3,TimeS
	lsl	temp3
	mov	temp,temp3
	lsl	temp3
	add	temp3,temp	;LED POS:temp3<-TimeS*6

	ldi	temp,60
	cp	temp3,temp
	brcs	PC+2
	sub	temp3,temp	;mod(temp3,60) (Times:0to119)
	rjmp	M5_LEDD		;->LED Draw

M5_CT1150:		;-------- case TimeS:11-50
	mov	temp2,TimeS
	ldi	temp,10
	clr	loop

	sub	temp2,temp
	brcs	PC+3
	inc	loop
	rjmp	PC-3
	add	temp2,temp	;TimeS 10s->loop, 1s->temp2

	clr	temp3		;temp3:LED POS=9*([10s]-1)+[1s]*7-1
				;if([1s]=0) POS++
	dec	loop
	mov	temp,loop	
	lsl	temp
	lsl	temp
	lsl	temp
	add	temp,loop	;temp3<-(loop-1)*9
	add	temp3,temp

	mov	temp,temp2
	add	temp,temp2
	add	temp,temp2
	add	temp,temp2
	add	temp,temp2
	add	temp,temp2
	add	temp,temp2	;temp3<-temp2*7
	add	temp3,temp

	dec	temp3		;temp3-1

	cpi	temp2,0		;temp2[1s]=0?
	brne	PC+2		;->no
	inc	temp3		;->yes temp3+1

	ldi	temp,60
	cp	temp3,temp
	brcs	PC+2
	sub	temp3,temp	;mod(temp3,60) (Times:0to119)

M5_LEDD:		;--- led draw
	ldiw	Z,dim_fs	;Z=dim_fs
	add	ZL,frame
	adc	ZH,ZEROR	;Z+frame
	ld	temp2,Z		;frame parameter load

	ldiw	Z,leddot	;Z=leddot
	add	ZL,temp3	;Z+POS
	adc	ZH,ZEROR
	st	Z,temp2		;(Z)=dim

M5_ED:	ret
;------------------------------ mode5 initialize----
MODE_5INI:
	rcall	DOTACLR	
	ret
;------------------------------------------------------------ mode3 furico 1
MODE_3:
	ldi	temp2,0
	mov	temp,TimeS
	ror	temp
	brcc	PC+2
	ldi	temp2,31

	ldiw	Z,R2_F0
	add	ZL,temp2
	adc	ZH,ZEROR	;31 times plus

	add	ZL,frame
	adc	ZH,ZEROR	
	ijmp

R2_F0:	rjmp	R2_L0
R2_F1:	rjmp	R2_L1
R2_F2:	rjmp	R2_L2
R2_F3:	rjmp	R2_L3
R2_F4:	rjmp	R2_L4
R2_F5:	rjmp	R2_L5
R2_F6:	rjmp	R2_L6
R2_F7:	rjmp	R2_L7
R2_F8:	rjmp	R2_L8
R2_F9:	rjmp	R2_L9
R2_F10:	rjmp	R2_L10
R2_F11:	rjmp	R2_L11
R2_F12:	rjmp	R2_L12
R2_F13:	rjmp	R2_L13
R2_F14:	rjmp	R2_L14
R2_F15:	rjmp	R2_L15
R2_F16:	rjmp	R2_L16
R2_F17:	rjmp	R2_L17
R2_F18:	rjmp	R2_L18
R2_F19:	rjmp	R2_L19
R2_F20:	rjmp	R2_L20
R2_F21:	rjmp	R2_L21
R2_F22:	rjmp	R2_L22
R2_F23:	rjmp	R2_L23
R2_F24:	rjmp	R2_L24
R2_F25:	rjmp	R2_L25
R2_F26:	rjmp	R2_L26
R2_F27:	rjmp	R2_L27
R2_F28:	rjmp	R2_L28
R2_F29:	rjmp	R2_L29
R2_F30:	rjmp	R2_L30
R2_F31:	rjmp	R2_L31
R2_F32:	rjmp	R2_L32
R2_F33:	rjmp	R2_L33
R2_F34:	rjmp	R2_L34
R2_F35:	rjmp	R2_L35
R2_F36:	rjmp	R2_L36
R2_F37:	rjmp	R2_L37
R2_F38:	rjmp	R2_L38
R2_F39:	rjmp	R2_L39
R2_F40:	rjmp	R2_L40
R2_F41:	rjmp	R2_L41
R2_F42:	rjmp	R2_L42
R2_F43:	rjmp	R2_L43
R2_F44:	rjmp	R2_L44
R2_F45:	rjmp	R2_L45
R2_F46:	rjmp	R2_L46
R2_F47:	rjmp	R2_L47
R2_F48:	rjmp	R2_L48
R2_F49:	rjmp	R2_L49
R2_F50:	rjmp	R2_L50
R2_F51:	rjmp	R2_L51
R2_F52:	rjmp	R2_L52
R2_F53:	rjmp	R2_L53
R2_F54:	rjmp	R2_L54
R2_F55:	rjmp	R2_L55
R2_F56:	rjmp	R2_L56
R2_F57:	rjmp	R2_L57
R2_F58:	rjmp	R2_L58
R2_F59:	rjmp	R2_L59
R2_F60:	rjmp	R2_L60
R2_F61:	rjmp	R2_L61
R2_F62:	nop	

R2_L0:	
	ldiw	Z,leddot
	stdi	Z+41,dim_8

	rjmp	R2_M3FIN
R2_L1:
	ldiw	Z,leddot
	stdi	Z+41,dim_8

	rjmp	R2_M3FIN
R2_L2:
	ldiw	Z,leddot
	stdi	Z+41,dim_8

	rjmp	R2_M3FIN
R2_L3:
	ldiw	Z,leddot
	stdi	Z+41,dim_8
	
	rjmp	R2_M3FIN
R2_L4:
	ldiw	Z,leddot
	stdi	Z+41,dim_5
	stdi	Z+40,dim_8
	
	rjmp	R2_M3FIN
R2_L5:
	ldiw	Z,leddot
	stdi	Z+41,dim_3
	stdi	Z+40,dim_8

	rjmp	R2_M3FIN
R2_L6:
	ldiw	Z,leddot
	stdi	Z+41,dim_2
	stdi	Z+40,dim_8

	rjmp	R2_M3FIN
R2_L7:
	ldiw	Z,leddot
	stdi	Z+41,dim_1
	stdi	Z+40,dim_5
	stdi	Z+39,dim_8

	rjmp	R2_M3FIN
R2_L8:
	ldiw	Z,leddot
	stdi	Z+41,dim_1
	stdi	Z+40,dim_3
	stdi	Z+39,dim_8

	rjmp	R2_M3FIN
R2_L9:
	ldiw	Z,leddot
	stdi	Z+41,dim_0
	stdi	Z+40,dim_2
	stdi	Z+39,dim_5
	stdi	Z+38,dim_8
	rjmp	R2_M3FIN
R2_L10:
	ldiw	Z,leddot
	stdi	Z+40,dim_1
	stdi	Z+39,dim_3
	stdi	Z+38,dim_8

	rjmp	R2_M3FIN	
R2_L11:
	ldiw	Z,leddot
	stdi	Z+40,dim_0
	stdi	Z+39,dim_1
	stdi	Z+38,dim_3
	stdi	Z+37,dim_8

	rjmp	R2_M3FIN
R2_L12:
	ldiw	Z,leddot
	stdi	Z+39,dim_0
	stdi	Z+38,dim_1
	stdi	Z+37,dim_3
	stdi	Z+36,dim_8

	rjmp	R2_M3FIN
R2_L13:
	ldiw	Z,leddot
	stdi	Z+38,dim_0
	stdi	Z+37,dim_1
	stdi	Z+36,dim_3
	stdi	Z+35,dim_8

	rjmp	R2_M3FIN
R2_L14:
	ldiw	Z,leddot
	stdi	Z+37,dim_0
	stdi	Z+36,dim_0
	stdi	Z+35,dim_1
	stdi	Z+34,dim_3
	stdi	Z+33,dim_8

	rjmp	R2_M3FIN
R2_L15:
	ldiw	Z,leddot
	stdi	Z+35,dim_0
	stdi	Z+34,dim_0
	stdi	Z+33,dim_0
	stdi	Z+32,dim_1
	stdi	Z+31,dim_3
	stdi	Z+30,dim_8

	rjmp	R2_M3FIN
R2_L16:
	ldiw	Z,leddot
	stdi	Z+32,dim_0
	stdi	Z+31,dim_0
	stdi	Z+30,dim_0
	stdi	Z+29,dim_1
	stdi	Z+28,dim_3
	stdi	Z+27,dim_8

	rjmp	R2_M3FIN
R2_L17:
	ldiw	Z,leddot
	stdi	Z+29,dim_0
	stdi	Z+28,dim_0
	stdi	Z+27,dim_1
	stdi	Z+26,dim_3
	stdi	Z+25,dim_8

	rjmp	R2_M3FIN
R2_L18:
	ldiw	Z,leddot
	stdi	Z+27,dim_0
	stdi	Z+26,dim_1
	stdi	Z+25,dim_3
	stdi	Z+24,dim_8

	rjmp	R2_M3FIN
R2_L19:
	ldiw	Z,leddot
	stdi	Z+26,dim_0
	stdi	Z+25,dim_1
	stdi	Z+24,dim_3
	stdi	Z+23,dim_8

	rjmp	R2_M3FIN
R2_L20:
	ldiw	Z,leddot
	stdi	Z+25,dim_0
	stdi	Z+24,dim_2
	stdi	Z+23,dim_5
	stdi	Z+22,dim_8

	rjmp	R2_M3FIN	
R2_L21:
	ldiw	Z,leddot
	stdi	Z+24,dim_1
	stdi	Z+23,dim_3
	stdi	Z+22,dim_8

	rjmp	R2_M3FIN
R2_L22:
	ldiw	Z,leddot
	stdi	Z+24,dim_0
	stdi	Z+23,dim_2
	stdi	Z+22,dim_5
	stdi	Z+21,dim_8
		
	rjmp	R2_M3FIN
R2_L23:
	ldiw	Z,leddot
	stdi	Z+23,dim_1
	stdi	Z+22,dim_3
	stdi	Z+21,dim_8

	rjmp	R2_M3FIN
R2_L24:
	ldiw	Z,leddot
	stdi	Z+23,dim_0
	stdi	Z+22,dim_2
	stdi	Z+21,dim_5
	stdi	Z+20,dim_8

	rjmp	R2_M3FIN
R2_L25:
	ldiw	Z,leddot
	stdi	Z+22,dim_1
	stdi	Z+21,dim_3
	stdi	Z+20,dim_8

	rjmp	R2_M3FIN
R2_L26:
	ldiw	Z,leddot
	stdi	Z+22,dim_0
	stdi	Z+21,dim_2
	stdi	Z+20,dim_8

	rjmp	R2_M3FIN
R2_L27:
	ldiw	Z,leddot
	stdi	Z+21,dim_1
	stdi	Z+20,dim_3
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN
R2_L28:
	ldiw	Z,leddot
	stdi	Z+21,dim_0
	stdi	Z+20,dim_2
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN
R2_L29:
	ldiw	Z,leddot
	stdi	Z+20,dim_1
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN
R2_L30:
	ldiw	Z,leddot
	stdi	Z+20,dim_0
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN	
;---------
R2_L31:
	ldiw	Z,leddot
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN
R2_L32:
	ldiw	Z,leddot
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN
R2_L33:
	ldiw	Z,leddot
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN
R2_L34:
	ldiw	Z,leddot
	stdi	Z+19,dim_8

	rjmp	R2_M3FIN
R2_L35:
	ldiw	Z,leddot
	stdi	Z+19,dim_5
	stdi	Z+20,dim_8

	rjmp	R2_M3FIN
R2_L36:
	ldiw	Z,leddot
	stdi	Z+19,dim_3
	stdi	Z+20,dim_8

	rjmp	R2_M3FIN
R2_L37:
	ldiw	Z,leddot
	stdi	Z+19,dim_2
	stdi	Z+20,dim_8

	rjmp	R2_M3FIN
R2_L38:
	ldiw	Z,leddot
	stdi	Z+19,dim_1
	stdi	Z+20,dim_5
	stdi	Z+21,dim_8

	rjmp	R2_M3FIN
R2_L39:
	ldiw	Z,leddot
	stdi	Z+19,dim_1
	stdi	Z+20,dim_3
	stdi	Z+21,dim_8

	rjmp	R2_M3FIN
R2_L40:
	ldiw	Z,leddot
	stdi	Z+19,dim_0
	stdi	Z+20,dim_2
	stdi	Z+21,dim_5
	stdi	Z+22,dim_8

	rjmp	R2_M3FIN	
R2_L41:
	ldiw	Z,leddot
	stdi	Z+20,dim_1
	stdi	Z+21,dim_3
	stdi	Z+22,dim_8

	rjmp	R2_M3FIN
R2_L42:
	ldiw	Z,leddot
	stdi	Z+20,dim_0
	stdi	Z+21,dim_1
	stdi	Z+22,dim_3
	stdi	Z+23,dim_8

	rjmp	R2_M3FIN
R2_L43:
	ldiw	Z,leddot
	stdi	Z+21,dim_0
	stdi	Z+22,dim_1
	stdi	Z+23,dim_3
	stdi	Z+24,dim_8

	rjmp	R2_M3FIN
R2_L44:
	ldiw	Z,leddot
	stdi	Z+22,dim_0
	stdi	Z+23,dim_1
	stdi	Z+24,dim_3
	stdi	Z+25,dim_8

	rjmp	R2_M3FIN
R2_L45:
	ldiw	Z,leddot
	stdi	Z+23,dim_0
	stdi	Z+24,dim_0
	stdi	Z+25,dim_1
	stdi	Z+26,dim_3
	stdi	Z+27,dim_8

	rjmp	R2_M3FIN
R2_L46:
	ldiw	Z,leddot
	stdi	Z+25,dim_0
	stdi	Z+26,dim_0
	stdi	Z+27,dim_0
	stdi	Z+28,dim_1
	stdi	Z+29,dim_3
	stdi	Z+30,dim_8

	rjmp	R2_M3FIN
R2_L47:
	ldiw	Z,leddot
	stdi	Z+28,dim_0
	stdi	Z+29,dim_0
	stdi	Z+30,dim_0
	stdi	Z+31,dim_1
	stdi	Z+32,dim_3
	stdi	Z+33,dim_8

	rjmp	R2_M3FIN
R2_L48:
	ldiw	Z,leddot
	stdi	Z+31,dim_0
	stdi	Z+32,dim_0
	stdi	Z+33,dim_1
	stdi	Z+34,dim_3
	stdi	Z+35,dim_8

	rjmp	R2_M3FIN
R2_L49:
	ldiw	Z,leddot
	stdi	Z+33,dim_0
	stdi	Z+34,dim_1
	stdi	Z+35,dim_3
	stdi	Z+36,dim_8

	rjmp	R2_M3FIN
R2_L50:
	ldiw	Z,leddot
	stdi	Z+34,dim_0
	stdi	Z+35,dim_1
	stdi	Z+36,dim_3
	stdi	Z+37,dim_8

	rjmp	R2_M3FIN	
R2_L51:
	ldiw	Z,leddot
	stdi	Z+35,dim_0
	stdi	Z+36,dim_2
	stdi	Z+37,dim_5
	stdi	Z+38,dim_8

	rjmp	R2_M3FIN
R2_L52:
	ldiw	Z,leddot
	stdi	Z+36,dim_1
	stdi	Z+37,dim_3
	stdi	Z+38,dim_8

	rjmp	R2_M3FIN
R2_L53:
	ldiw	Z,leddot
	stdi	Z+36,dim_0
	stdi	Z+37,dim_2
	stdi	Z+38,dim_5
	stdi	Z+39,dim_8

	rjmp	R2_M3FIN
R2_L54:
	ldiw	Z,leddot
	stdi	Z+37,dim_1
	stdi	Z+38,dim_3
	stdi	Z+39,dim_8

	rjmp	R2_M3FIN
R2_L55:
	ldiw	Z,leddot
	stdi	Z+37,dim_0
	stdi	Z+38,dim_2
	stdi	Z+39,dim_5
	stdi	Z+40,dim_8

	rjmp	R2_M3FIN
R2_L56:
	ldiw	Z,leddot
	stdi	Z+38,dim_1
	stdi	Z+39,dim_3
	stdi	Z+40,dim_8

	rjmp	R2_M3FIN
R2_L57:
	ldiw	Z,leddot
	stdi	Z+38,dim_0
	stdi	Z+39,dim_2
	stdi	Z+40,dim_8

	rjmp	R2_M3FIN
R2_L58:
	ldiw	Z,leddot
	stdi	Z+39,dim_1
	stdi	Z+40,dim_3
	stdi	Z+41,dim_8

	rjmp	R2_M3FIN
R2_L59:
	ldiw	Z,leddot
	stdi	Z+39,dim_0
	stdi	Z+40,dim_2
	stdi	Z+41,dim_8

	rjmp	R2_M3FIN
R2_L60:
	ldiw	Z,leddot
	stdi	Z+40,dim_1
	stdi	Z+41,dim_8

	rjmp	R2_M3FIN	
R2_L61:
	ldiw	Z,leddot
	stdi	Z+40,dim_0
	stdi	Z+41,dim_8

	rjmp	R2_M3FIN	

R2_M3FIN:
	ret

;------------------------------ mode3 initialize----
MODE_3INI:
	rcall	DOTACLR	
	ret
;--------------------------------------------- mode1 normal scan with dim
MODE_1:
	mov	temp,TimeS
	cpi	temp,0
	breq	M1CASE0		;TimeS=0

	ldiw	Z,dim_fs	;Z=dim_fs
	add	ZL,frame
	adc	ZH,ZEROR	;Z+frame
	ld	temp2,Z		;frame parameter load

	ldiw	Z,leddot	;Z=leddot
	add	ZL,temp		;Z+TimeS
	st	Z+,temp2	;(Z)=dim
	ret


M1CASE0:
	ldiw	Z,dim_fs2	;Z=dim_fs2
	add	ZL,frame
	adc	ZH,ZEROR	;Z+frame
	ld	temp2,Z		;frame parameter load

	ldi	loop,60
	ldiw	Z,leddot

M1C0_L1:
	st	Z+,temp2
	dec	loop
	brne	M1C0_L1		;60th loop
	ret
;------------------------------ mode1 initialize----
MODE_1INI:
	rcall	DOTACLR

	mov	loop,TimeS
	cpi	loop,2
	brcs	M1INI_E		;TimeS<=1 ->pass
	ldiw	Z,leddot
	inc	ZL	;Z=leddot+1
	dec	loop
	ldi	temp,dim_1
M1INIL2:
	st	Z+,temp
	dec	loop
	brne	M1INIL2
M1INI_E:
	ret


;------------------------------------------------------------------- mode2 ziwaziwa
MODE_2:
	ldiw	Z,R1_F0
	add	ZL,frame
	adc	ZH,ZEROR	

	ijmp

R1_F0:	rjmp	R1_L0
R1_F1:	rjmp	R1_L1
R1_F2:	rjmp	R1_L2
R1_F3:	rjmp	R1_L3
R1_F4:	rjmp	R1_L4
R1_F5:	rjmp	R1_L5
R1_F6:	rjmp	R1_L6
R1_F7:	rjmp	R1_L7
R1_F8:	rjmp	R1_L8
R1_F9:	rjmp	R1_L9
R1_F10:	rjmp	R1_L10
R1_F11:	rjmp	R1_L11
R1_F12:	rjmp	R1_L12
R1_F13:	rjmp	R1_L13
R1_F14:	rjmp	R1_L14
R1_F15:	rjmp	R1_L15
R1_F16:	rjmp	R1_L16
R1_F17:	rjmp	R1_L17
R1_F18:	rjmp	R1_L18
R1_F19:	rjmp	R1_L19
R1_F20:	rjmp	R1_L20
R1_F21:	rjmp	R1_L21
R1_F22:	rjmp	R1_L22
R1_F23:	rjmp	R1_L23
R1_F24:	rjmp	R1_L24
R1_F25:	rjmp	R1_L25
R1_F26:	rjmp	R1_L26
R1_F27:	rjmp	R1_L27
R1_F28:	rjmp	R1_L28
R1_F29:	rjmp	R1_L29
R1_F30:	rjmp	R1_L30
R1_F31:	


R1_L0:;	rjmp	R1_M3FIN
R1_L1:;	rjmp	R1_M3FIN
R1_L2:;	rjmp	R1_M3FIN
R1_L3:;	rjmp	R1_M3FIN
R1_L4:;	rjmp	R1_M3FIN
R1_L5:;	rjmp	R1_M3FIN
R1_L6:	rjmp	R1_M3FIN
R1_L7:	
	rcall	ACC60
	ldiw	Z,leddot
	add	ZL,r12	;led
	adc	ZH,ZEROR
	sti	Z,dim_7

	rjmp	R1_M3FIN

R1_L8:;	rjmp	R1_M3FIN
R1_L9:	rjmp	R1_M3FIN
R1_L10:	
	rcall	ACC60

	ldiw	Z,leddot
	add	ZL,r10	;led-2
	adc	ZH,ZEROR
	sti	Z,dim_2

	ldiw	Z,leddot
	add	ZL,r11	;led-1
	adc	ZH,ZEROR
	sti	Z,dim_5

	ldiw	Z,leddot
	add	ZL,r13	;led+1
	adc	ZH,ZEROR
	sti	Z,dim_4

	ldiw	Z,leddot
	add	ZL,r14	;led+2
	adc	ZH,ZEROR
	sti	Z,dim_1

	rjmp	R1_M3FIN	
	
R1_L11:;rjmp	R1_M3FIN
R1_L12:;rjmp	R1_M3FIN
R1_L13:;rjmp	R1_M3FIN
R1_L14:	rjmp	R1_M3FIN
R1_L15:	
	rcall	ACC60
	ldiw	Z,leddot
	add	ZL,r12	;led
	adc	ZH,ZEROR
	sti	Z,dim_8

	rjmp	R1_M3FIN
R1_L16:;rjmp	R1_M3FIN
R1_L17:;rjmp	R1_M3FIN
R1_L18:;rjmp	R1_M3FIN
R1_L19:	rjmp	R1_M3FIN
R1_L20:	
	rcall	ACC60
	ldiw	Z,leddot
	add	ZL,r10	;led-2
	adc	ZH,ZEROR
	sti	Z,dim_1

	ldiw	Z,leddot
	add	ZL,r11	;led-1
	adc	ZH,ZEROR
	sti	Z,dim_4

	ldiw	Z,leddot
	add	ZL,r13	;led+1
	adc	ZH,ZEROR
	sti	Z,dim_5

	ldiw	Z,leddot
	add	ZL,r14	;led+2
	adc	ZH,ZEROR
	sti	Z,dim_2


	rjmp	R1_M3FIN	

R1_L21:;rjmp	R1_M3FIN
R1_L22:	rjmp	R1_M3FIN
R1_L23:	
	rcall	ACC60
	ldiw	Z,leddot
	add	ZL,r12	;led
	adc	ZH,ZEROR
	sti	Z,dim_7
	

	rjmp	R1_M3FIN
R1_L24:;rjmp	R1_M3FIN
R1_L25:;rjmp	R1_M3FIN
R1_L26:;rjmp	R1_M3FIN
R1_L27:;rjmp	R1_M3FIN
R1_L28:;rjmp	R1_M3FIN
R1_L29:	rjmp	R1_M3FIN
R1_L30:	
	rcall	ACC60
	ldiw	Z,leddot
	add	ZL,r10	;led-2
	adc	ZH,ZEROR
	sti	Z,dim_0

	ldiw	Z,leddot
	add	ZL,r11	;led-1
	adc	ZH,ZEROR
	sti	Z,dim_3

	ldiw	Z,leddot
	add	ZL,r13	;led+1
	adc	ZH,ZEROR
	sti	Z,dim_6

	ldiw	Z,leddot
	add	ZL,r14	;led+2
	adc	ZH,ZEROR
	sti	Z,dim_3

	ldiw	Z,leddot
	add	ZL,r12	;led
	adc	ZH,ZEROR
	sti	Z,dim_6

	rjmp	R1_M3FIN	

R1_M3FIN:
	ret

;----------------
ACC60:
	mov	temp,TimeS
	ldi	loop,60
	mov	r12,TimeS
	dec	temp
	cpi	temp,60
	brcs	PC+2
	add	temp,loop

	mov	r11,temp
	dec	temp
	cpi	temp,60
	brcs	PC+2
	add	temp,loop

	mov	r10,temp
	mov	temp,TimeS
	inc	temp
	cpi	temp,60
	brcs	PC+2
	sub	temp,loop

	mov	r13,temp
	inc	temp
	cpi	temp,60
	brcs	PC+2
	sub	temp,loop

	mov	r14,temp
	ret
;------------------------------ mode2 initialize----
MODE_2INI:
	rcall	DOTACLR	
	ret
;------------------------------------- subroutines
;------------ leddot all clear
DOTACLR:
	ldi	loop,60
	ldiw	Z,leddot
	ldi	temp,0
DCINIL1:			;all led=0
	st	Z+,temp
	dec	loop
	brne	DCINIL1
	ret

;------------------------------------------------------ mode6 moon
MODE_6:
	mov	temp,TimeS
	cpi	temp,0
	brne	PC+2	
	rjmp	R6_M3FIN	;T=0
	cpi	temp,1
	brne	PC+2
	rjmp	R6_F1		;T=1
	cpi	temp,30
	brcc	PC+2
	rjmp	R6_F229		;(1<=)T<30
	cpi	temp,30
	brne	PC+2
	rjmp	R6_F30		;T=30
	cpi	temp,31
	brne	PC+2
	rjmp	R6_F31		;T=31
	cpi	temp,59
	brcc	PC+2
	rjmp	R6_F3258	;(32<=)T<59
	cpi	temp,59
	brne	PC+2
	rjmp	R6_F59		;T=59

	rjmp	R6_M3FIN	;other


;---------------
R6_F1:
	ldi	temp2,44
	rcall	M6_FS01
	ldi	temp2,45
	rcall	M6_FS01
	ldi	temp2,46
	rcall	M6_FS01

	rjmp	R6_M3FIN

;----------------
R6_F229:
	ldi	temp2,45
	sub	temp2,TimeS	;45-T
	rcall	M6_FS01

	ldi	temp2,45
	add	temp2,TimeS	;45+T
	cpi	temp2,60
	brcs	PC+2
	subi	temp2,60	;(45+T)>=60 -> <60
	rcall	M6_FS01

	ldi	temp2,45
	sub	temp2,TimeS
	inc	temp2		;45-(T-1)
	rcall	M6_FS18		

	ldi	temp2,45
	add	temp2,TimeS
	dec	temp2		;45+(T-1)
	cpi	temp2,60
	brcs	PC+2
	subi	temp2,60	;>60 -> -60
	rcall	M6_FS18

	mov	temp,TimeS
	cpi	temp,2
	breq	R6_F229_C1
	cpi	temp,29
	breq	R6_F229_C29
	rjmp	R6_M3FIN

R6_F229_C1:
	ldi	temp2,45
	rcall	M6_FS18
	rjmp	R6_M3FIN
R6_F229_C29:
	ldi	temp2,15
	rcall	M6_FS01
	rjmp	R6_M3FIN
;-----------------
R6_F30:
	ldi	temp2,14
	rcall	M6_FS18
	ldi	temp2,15
	rcall	M6_FS18
	ldi	temp2,16
	rcall	M6_FS18

	rjmp	R6_M3FIN

;-----------------
R6_F31:
	ldi	temp2,44
	rcall	M6_FS80
	ldi	temp2,45
	rcall	M6_FS80
	ldi	temp2,46
	rcall	M6_FS80

	ldi	temp2,43
	rcall	M6_FS81
	ldi	temp2,47
	rcall	M6_FS81

	rjmp	R6_M3FIN
;----------------
R6_F3258:
	ldi	temp2,74
	sub	temp2,TimeS	;45-(T-30+1) = 74-T
	rcall	M6_FS81

	ldi	temp2,16
	add	temp2,TimeS	;45+(T-30+1) = 16+T
	cpi	temp2,60
	brcs	PC+2
	subi	temp2,60	;>60 -> -60
	rcall	M6_FS81

	ldi	temp2,74
	sub	temp2,TimeS
	inc	temp2		;45-((T-1)-30+1) = 74-(T-1)
	rcall	M6_FS10		

	ldi	temp2,16
	add	temp2,TimeS
	dec	temp2		;45+((T-1)-30+1) = 16+(T-1)
	cpi	temp2,60
	brcs	PC+2
	subi	temp2,60	;>60 -> -60
	rcall	M6_FS10

	mov	temp,TimeS
	cpi	temp,58
	breq	R6_F3258_C58
	rjmp	R6_M3FIN

R6_F3258_C58:
	ldi	temp2,15
	rcall	M6_FS81
	rjmp	R6_M3FIN

;-----------------
R6_F59:
	ldi	temp2,14
	rcall	M6_FS10
	ldi	temp2,15
	rcall	M6_FS10
	ldi	temp2,16
	rcall	M6_FS10

	rjmp	R6_M3FIN

R6_M3FIN:
	ret
;------------------------------ mode6 initialize----
MODE_6INI:
	rcall	DOTACLR	

	mov	temp,TimeS
	cpi	temp,3
	brcc	PC+2	
	rjmp	R6I_FIN		;T<3 no action
	cpi	temp,31
	brcs	M6IC330		;(3<=)T<31
	breq	M6IC31		;T=31
	rjmp	M6IC3259	;31<T(<60)

M6IC330:
	ldi	temp,47
	sub	temp,TimeS	;temp=45-(n-2)	

	mov	loop,TimeS
	lsl	loop
	subi	loop,3		;temp=2T-3

	ldiw	Z,leddot
	add	ZL,temp		;Z=Z+temp
	adc	ZH,ZEROR
	ldi	temp2,dim_8
M6I_L1:	
	st	Z+,temp2
	dec	loop
	breq	M6I_L2

	cpi	ZL,low(leddot)+60
	brne	M6I_L1		;Z=leddot(60)->leddot(0)
	ldiw	Z,leddot
	rjmp	M6I_L1
M6I_L2:	rjmp	R6I_FIN
	
;---------------
M6IC31:	
	ldiw	Z,leddot
	ldi	loop,60
	ldi	temp2,dim_8

	st	Z+,temp2
	dec	loop
	brne	PC-2
	rjmp	R6I_FIN

;----------------
M6IC3259:
	ldi	temp,15
	add	temp,TimeS	;temp=T+15
	cpi	temp,60
	brcs	PC+2
	subi	temp,60
	
	mov	temp2,TimeS
	subi	temp2,32
	lsl	temp2
	ldi	loop,57
	sub	loop,temp2	;loop=57-2(T-32)

	ldiw	Z,leddot
	add	ZL,temp
	adc	ZH,ZEROR
	ldi	temp2,dim_8

M6I_L3:
	st	Z+,temp2
	dec	loop
	breq	M6I_L4

	cpi	ZL,low(leddot)+60
	brne	M6I_L3
	ldiw	Z,leddot
	rjmp	M6I_L3
M6I_L4:	rjmp	R6I_FIN

;----------------

R6I_FIN:
	ret

;-------------------------------------
M6_FS01:
.equ	M6_x01_1	=23


	mov	temp,frame
	cpi	temp,M6_x01_1
	brcc	PC+3
	ldi	loop,dim_0
	rjmp	PC+2
	ldi	loop,dim_1

;-------------- common LED Draw 
M6_LEDSET:
	ldiw	Z,leddot	;Z=leddot
	add	ZL,temp2
	adc	ZH,ZEROR	
	st	Z,loop		;(Z)=dim
	ret
;-------------------------------------
M6_FS13:
.equ	M6_x13_2	=12
.equ	M6_x13_3	=22

	mov	temp,frame
	cpi	temp,M6_x13_2
	brcc	PC+3
	ldi	loop,dim_1
	rjmp	FS13_ED
	cpi	temp,M6_x13_3
	brcc	PC+3
	ldi	loop,dim_2
	rjmp	FS13_ED
	ldi	loop,dim_3

FS13_ED:rjmp	M6_LEDSET



;-------------------------------------
M6_FS03:
.equ	M6_x03_1	=7
.equ	M6_x03_2	=16
.equ	M6_x03_3	=24

	mov	temp,frame
	cpi	temp,M6_x03_1
	brcc	PC+3
	ldi	loop,dim_0
	rjmp	FS03_ED
	cpi	temp,M6_x03_2
	brcc	PC+3
	ldi	loop,dim_1
	rjmp	FS03_ED
	cpi	temp,M6_x03_3
	brcc	PC+3
	ldi	loop,dim_2
	rjmp	FS03_ED
	ldi	loop,dim_3

FS03_ED:rjmp	M6_LEDSET


;-------------------------------------
M6_FS08:
.equ	M6_x08_1	=2
.equ	M6_x08_2	=7
.equ	M6_x08_3	=12
.equ	M6_x08_4	=16
.equ	M6_x08_5	=19
.equ	M6_x08_6	=22
.equ	M6_x08_7	=25
.equ	M6_x08_8	=28

	mov	temp,frame
	cpi	temp,M6_x08_1
	brcc	PC+3
	ldi	loop,dim_0
	rjmp	FS08_ED
	cpi	temp,M6_x08_2
	brcc	PC+3
	ldi	loop,dim_1
	rjmp	FS08_ED
	cpi	temp,M6_x08_3
	brcc	PC+3
	ldi	loop,dim_2
	rjmp	FS08_ED
	cpi	temp,M6_x08_4
	brcc	PC+3
	ldi	loop,dim_3
	rjmp	FS08_ED
	cpi	temp,M6_x08_5
	brcc	PC+3
	ldi	loop,dim_4
	rjmp	FS08_ED
	cpi	temp,M6_x08_6
	brcc	PC+3
	ldi	loop,dim_5
	rjmp	FS08_ED
	cpi	temp,M6_x08_7
	brcc	PC+3
	ldi	loop,dim_6
	rjmp	FS08_ED
	cpi	temp,M6_x08_8
	brcc	PC+3
	ldi	loop,dim_7
	rjmp	FS08_ED
	ldi	loop,dim_8

FS08_ED:rjmp	M6_LEDSET
;-------------------------------------
M6_FS18:
.equ	M6_x18_2	=5
.equ	M6_x18_3	=10
.equ	M6_x18_4	=14
.equ	M6_x18_5	=18
.equ	M6_x18_6	=22
.equ	M6_x18_7	=25
.equ	M6_x18_8	=28


	mov	temp,frame
	cpi	temp,M6_x18_2
	brcc	PC+3
	ldi	loop,dim_1
	rjmp	FS18_ED
	cpi	temp,M6_x18_3
	brcc	PC+3
	ldi	loop,dim_2
	rjmp	FS18_ED
	cpi	temp,M6_x18_4
	brcc	PC+3
	ldi	loop,dim_3
	rjmp	FS18_ED
	cpi	temp,M6_x18_5
	brcc	PC+3
	ldi	loop,dim_4
	rjmp	FS18_ED
	cpi	temp,M6_x18_6
	brcc	PC+3
	ldi	loop,dim_5
	rjmp	FS18_ED
	cpi	temp,M6_x18_7
	brcc	PC+3
	ldi	loop,dim_6
	rjmp	FS18_ED
	cpi	temp,M6_x18_8
	brcc	PC+3
	ldi	loop,dim_7
	rjmp	FS18_ED
	ldi	loop,dim_8

FS18_ED:rjmp	M6_LEDSET
;-------------------------------------
M6_FS81:
.equ	M6_x81_7	=3
.equ	M6_x81_6	=6
.equ	M6_x81_5	=9
.equ	M6_x81_4	=13
.equ	M6_x81_3	=17
.equ	M6_x81_2	=21
.equ	M6_x81_1	=26


	mov	temp,frame
	cpi	temp,M6_x81_7
	brcc	PC+3
	ldi	loop,dim_8
	rjmp	FS81_ED
	cpi	temp,M6_x81_6
	brcc	PC+3
	ldi	loop,dim_7
	rjmp	FS81_ED
	cpi	temp,M6_x81_5
	brcc	PC+3
	ldi	loop,dim_6
	rjmp	FS81_ED
	cpi	temp,M6_x81_4
	brcc	PC+3
	ldi	loop,dim_5
	rjmp	FS81_ED
	cpi	temp,M6_x81_3
	brcc	PC+3
	ldi	loop,dim_4
	rjmp	FS81_ED
	cpi	temp,M6_x81_2
	brcc	PC+3
	ldi	loop,dim_3
	rjmp	FS81_ED
	cpi	temp,M6_x81_1
	brcc	PC+3
	ldi	loop,dim_2
	rjmp	FS81_ED
	ldi	loop,dim_1

FS81_ED:rjmp	M6_LEDSET

;-------------------------------------
M6_FS80:
.equ	M6_x80_7	=3
.equ	M6_x80_6	=6
.equ	M6_x80_5	=9
.equ	M6_x80_4	=12
.equ	M6_x80_3	=15
.equ	M6_x80_2	=19
.equ	M6_x80_1	=24
.equ	M6_x80_0	=29

	mov	temp,frame
	cpi	temp,M6_x80_7
	brcc	PC+3
	ldi	loop,dim_8
	rjmp	FS80_ED
	cpi	temp,M6_x80_6
	brcc	PC+3
	ldi	loop,dim_7
	rjmp	FS80_ED
	cpi	temp,M6_x80_5
	brcc	PC+3
	ldi	loop,dim_6
	rjmp	FS80_ED
	cpi	temp,M6_x80_4
	brcc	PC+3
	ldi	loop,dim_5
	rjmp	FS80_ED
	cpi	temp,M6_x80_3
	brcc	PC+3
	ldi	loop,dim_4
	rjmp	FS80_ED
	cpi	temp,M6_x80_2
	brcc	PC+3
	ldi	loop,dim_3
	rjmp	FS80_ED
	cpi	temp,M6_x80_1
	brcc	PC+3
	ldi	loop,dim_2
	rjmp	FS80_ED
	cpi	temp,M6_x80_0
	brcc	PC+3
	ldi	loop,dim_1
	rjmp	FS80_ED
	ldi	loop,dim_0

FS80_ED:rjmp	M6_LEDSET
;-------------------------------------
M6_FS30:
.equ	M6_x30_2	=7
.equ	M6_x30_1	=15
.equ	M6_x30_0	=24

	mov	temp,frame
	cpi	temp,M6_x30_2
	brcc	PC+3
	ldi	loop,dim_3
	rjmp	FS30_ED
	cpi	temp,M6_x30_1
	brcc	PC+3
	ldi	loop,dim_2
	rjmp	FS30_ED
	cpi	temp,M6_x30_0
	brcc	PC+3
	ldi	loop,dim_1
	rjmp	FS30_ED
	ldi	loop,dim_0

FS30_ED:rjmp	M6_LEDSET
;-------------------------------------
M6_FS10:
.equ	M6_x10_0	=8

	mov	temp,frame
	cpi	temp,M6_x10_0
	brcc	PC+3
	ldi	loop,dim_1
	rjmp	FS10_ED
	ldi	loop,dim_0
FS10_ED:rjmp	M6_LEDSET

;-------------------------------------
M6_FS38:
.equ	M6_x38_4	=6
.equ	M6_x38_5	=12
.equ	M6_x38_6	=17
.equ	M6_x38_7	=21
.equ	M6_x38_8	=25


	mov	temp,frame
	cpi	temp,M6_x38_4
	brcc	PC+3
	ldi	loop,dim_3
	rjmp	FS38_ED
	cpi	temp,M6_x38_5
	brcc	PC+3
	ldi	loop,dim_4
	rjmp	FS38_ED
	cpi	temp,M6_x38_6
	brcc	PC+3
	ldi	loop,dim_5
	rjmp	FS38_ED
	cpi	temp,M6_x38_7
	brcc	PC+3
	ldi	loop,dim_6
	rjmp	FS38_ED
	cpi	temp,M6_x38_8
	brcc	PC+3
	ldi	loop,dim_7
	rjmp	FS38_ED
	ldi	loop,dim_8

FS38_ED:rjmp	M6_LEDSET
;-------------------------------------
M6_FS83:
.equ	M6_x83_7	=6
.equ	M6_x83_6	=10
.equ	M6_x83_5	=14
.equ	M6_x83_4	=19
.equ	M6_x83_3	=25


	mov	temp,frame
	cpi	temp,M6_x83_7
	brcc	PC+3
	ldi	loop,dim_8
	rjmp	FS83_ED
	cpi	temp,M6_x83_6
	brcc	PC+3
	ldi	loop,dim_7
	rjmp	FS83_ED
	cpi	temp,M6_x83_5
	brcc	PC+3
	ldi	loop,dim_6
	rjmp	FS83_ED
	cpi	temp,M6_x83_4
	brcc	PC+3
	ldi	loop,dim_5
	rjmp	FS83_ED
	cpi	temp,M6_x83_3
	brcc	PC+3
	ldi	loop,dim_4
	rjmp	FS83_ED
	ldi	loop,dim_3

FS83_ED:rjmp	M6_LEDSET


